
class BankCard{
  var pin : int;
  var accNo : int;
  var valid : bool;
  

  method Init(p : int, a : int)
  modifies this;
  ensures valid == true;
  ensures pin == p;
  ensures accNo == a;
  {
    pin := p; accNo := a; valid := true;
  }
  
  method isPinOK(p : int ) returns (res: bool)
  ensures res <==> (valid && pin == p);
  {
    if (!this.valid) {res := false;}
    else {res := this.pin == p;}
  }
  
  method invalidateCard()
  modifies this`valid;
  ensures !valid;
  {
    valid := false;
  }
  
  method isCardValid() returns (res: bool)
  ensures res == this.valid;
{
    res := this.valid;
  }
  
  method getAccNo() returns (res : int)
  ensures res == this.accNo;
  {
    res := this.accNo;
  }

function getPin() : int
   reads this;
  {
    this.pin
  }
  
function isValid() : bool
         reads this; {this.valid}
}



class ATM{
  var insertedCard : BankCard;
  var wrongPINCounter : int;
  var auth : bool;
  
  predicate ready()
  reads this;
  {insertedCard == null && wrongPINCounter == 0 && auth == false}

  method init()
  modifies this;
  ensures wrongPINCounter == 0;
  ensures auth == false;
  ensures insertedCard == null;
  {
  insertedCard := null; wrongPINCounter := 0; auth := false;
  }

  method insertCard(c : BankCard)
      modifies this`insertedCard;
      // ADD HERE !! 
  {
  insertedCard := c;
  }

  method spitCardOut() returns (card : BankCard)
     modifies this;
     // ADD HERE !!       
  {
  card := insertedCard;
  insertedCard := null; 
  wrongPINCounter := 0; 
  auth := false; 
  }

  method enterPIN(p : int)
  // This method may modify the ATM object, and its BankCard field.
  modifies this`auth, this`wrongPINCounter, this.insertedCard`valid;
  // ADD HERE.
    {
    if (p==insertedCard.pin){
      auth := true;
    }
    else{
      if(wrongPINCounter < 2)
        {wrongPINCounter := wrongPINCounter+1;}
      else
        {insertedCard.invalidateCard();}
    }
  }
}