// -------------------------------------------
// EXAMPLE2: Formal Specification Lecture 2     
// -------------------------------------------

method Abs(x : int) returns (r :int)
  ensures 0 <= r;
  // Needs these two additional post-constions to prove v==3
  ensures 0 <= x ==> r == x;
  ensures x < 0 ==> r == -x; 
{
  if (x < 0)
  {r := -x;}
  else {r := x;}
}


// A function can be used in annotation, unlike methods.
// Note: single expression in body, no semicolons!
function method abs(x : int) : int
{
  if x < 0 then -x else x
}


method Test(){
  // Note: Can't use method call in assertion, as methods may change state.
  var v := Abs(3);
  // 1) this is easy to prove, follow from post-cond of Abs. 
  assert 0 <= v;
  
  // 1) Cannot prove this with postcondition 0 <= r!
  // Dafny only remembers annotations for other methods,
  // not their bodies (efficiency reasons).
  assert v == 3;
  //assert v == abs(3);
}